package test.testutil;

import java.util.List;
import java.util.function.Function;
import java.util.stream.Collectors;

public class TestTool {

	public static void println(Object o) {
		System.out.println(o.toString());
	}

	public static void printf(String format, Object... args) {
		System.out.printf(format, args);
	}

	public static <T, S> List<S> map(List<T> list, Function<T, S> mapFct) {
		return list.stream().map(mapFct).collect(Collectors.toList());
	}

	public static String defaultToStringFor(Object o) {
		return o.getClass().getName() + "@" + Integer.toHexString(o.hashCode());
	}

	/** Returns String 0-100 (%) for equality closeness [this is rough] */
	public static int compareStringsAsPercent(String aExpected, String aActual) {
		//zap white		
		String
			expected = aExpected.replaceAll("\\s",""),
			actual = aActual.replaceAll("\\s","");		
		int
		matches = 0, l1 = expected.length(), l2 = actual.length(), min = Math.min(l1, l2),
				max = Math.max(l1, l2);
		for (int i = 0; i < min; i++) {
			String s1 = expected.substring(i, i + 1);
			String s2 = actual.substring(i, i + 1);
			if (s1.equalsIgnoreCase(s2))
				++matches;
		}
		return (int) Math.round(100.0 * matches / max);		
	}

}
